dofile("t_log.lua")
dofile("t_math.lua")
dofile("t_mission.lua")
dofile("t_clan_const.lua")
dofile("t_clan_desc.lua")
dofile("t_item_func.lua")
dofile("t_module.lua")
dofile("t_ghost.lua")
dofile("t_ghost_desc.lua")
dofile("t_land.lua")
dofile("t_object_id.lua")
dofile("t_planet_slot.lua")
dofile("t_planet_level.lua")
dofile("t_galaxy_const.lua")
dofile("m_local_common.lua")
dofile("m_auto_common.lua")
dofile("t_groups.lua")
dofile("t_ai.lua")
dofile("t_mission_class.lua")
G_SCRIPT_VERSION = 3
T_MISSION_EXIT_CODE = "LOCAL_C01_EXIT_CODE"
G_MISSION_RUNOUT_TIME = 350
T_LOCAL_C01P_DESC = {"T_LOCAL_C01AP_DESC", "T_LOCAL_C01BP_DESC", "T_LOCAL_C01CP_DESC"}
T_LOCAL_C01S_DESC = {"T_LOCAL_C01AS_DESC", "T_LOCAL_C01BS_DESC", "T_LOCAL_C01CS_DESC"}
script = {}
script.questSystem = {}
script.time_to_finish = nil
flags = {}
flags.isMissionStarted = false
OnMissionStart = function()
   script.star = _GAME:get("star", script.questSystem[1], script.questSystem[2], script.questSystem[3])
   assert(script.star)
   local pirates_count = random(6, 8)
   script.star:set("pirates_count", pirates_count)
   update_planet()
   create_info()
   t_show_message({g_sender_parkan, "T_ASSAULT_MSG"}, 6, 2)
   script.time_to_finish = 0
   addTimeEvent("doMissionEnd", G_MISSION_RUNOUT_TIME)
   startTimeEvent("doMissionEnd")
end

timer.doMissionEnd = function()
   Log("#m_local_c01\t\ttimer.doMissionEnd ___>\t\tscript.time_to_finish= ", script.time_to_finish)
   stopTimeEvent("doMissionEnd")
   removeTimeEvent("doMissionEnd")
   missionFailed()
end

OnMissionEnd = function()
   if script.colony then
      for slot = G_SPACE_SLOT_MID_0, G_SPACE_SLOT_MID_9 do
         script.colony:set("remove_space", slot)
      end
      script.colony:set("remove_build", script.land_slot)
      script.colony:set("mission", 0)
   end
end

OnMissionClear = function()
   if script.colony then
      script.colony:set("mission", 0)
   end
end

OnMissionSave = function(s)
   s:write(G_SCRIPT_VERSION)
   s:write(script)
   s:write(flags)
end

OnMissionLoad = function(s)
   local load_version = s:read()
   script = s:read()
   flags = s:read()
   Log("________________>>>>\tscript.time_to_finish= ", script.time_to_finish)
   if script.time_to_finish ~= nil then
      stopTimeEvent("doMissionEnd")
      removeTimeEvent("doMissionEnd")
      script.time_to_finish = 0
      addTimeEvent("doMissionEnd", G_MISSION_RUNOUT_TIME)
      startTimeEvent("doMissionEnd")
   end
   Log("+++++++++++++++++++>>>>\tscript.time_to_finish= ", script.time_to_finish)
end

update_planet = function()
   script.colony:set("mission", 1)
   for slot = G_SPACE_SLOT_NEAR_1, G_SPACE_SLOT_NEAR_9 do
      script.colony:set("remove_space", slot)
   end
   assert(script.star)
   script.race = script.star:get("race")
   local ship_count = random(1, 3)
   local pirate_id = t_race_get_pirate_id(script.race)
   local trader_id = t_race_get_trader_id(script.race)
   for i = 1, ship_count do
      script.colony:set("add_space", G_SPACE_SLOT_NEAR_1 + 2 * i, pirate_id, CLAN_ASTRON)
   end
   script.land_slot = t_planet_slot_get_rnd_free(script.colony)
   local coin = (random())
   local ship_id = nil
   if coin < 0.5 then
      ship_id = pirate_id
   else
      ship_id = trader_id
   end
   script.colony:set("add_build", script.land_slot, ship_id, CLAN_ASTRON)
end

create_info = function()
   local name = t_miss_get_space_names(script.questSystem)
   local planet = script.questSystem[4] + 1
   local sat = script.questSystem[5] + 1
   local miss_desc = nil
   if script.questSystem[5] ~= -1 then
      local index = random(1, 3)
      local string = T_LOCAL_C01P_DESC[index]
      miss_desc = {{string, planet, name[1], name[2], name[3]}}
   else
      local index = random(1, 3)
      local string = T_LOCAL_C01S_DESC[index]
      miss_desc = {{string, sat, planet, name[1], name[2], name[3]}}
   end
   missionInfo_c01 = {info_id = "ID_MC01", short = "T_LOCAL_C01_SHORT", desc = miss_desc, mesh = "inf_clan_pk.lmdl", mission = _THIS}
   t_mission_class:setMissInfo("mission_c01", missionInfo_c01)
   t_mission_class:showMissInfo("mission_c01", true)
end

event.game_change_space_land_post = function(self, planet)
   if not t_is_equal_mod(planet, script.colony) then
      return 
   end
   stopTimeEvent("doMissionEnd")
   local land_ship = G_LAND:get("Slot", script.land_slot)
   land_ship:set("race", script.race)
   local items_count = random(10, 20)
   t_ghost_fill_inventory(land_ship:getBot(), 1, items_count, G_ITEM_PIRATE_LOOT)
end

event.game_change_land_space_post = function(self, planet)
   if not t_is_equal_mod(planet, script.colony) then
      return 
   end
   startTimeEvent("doMissionEnd")
end

event.space_slot_show = function(self, planet, slot, ghost)
   if not t_is_equal_mod(planet, script.colony) then
      return 
   end
   local ship_clan = ghost:get("clan")
   if G_SPACE_SLOT_NEAR_0 < slot and CLAN_ASTRON == ship_clan then
      t_ai_unhold_fire(ghost:getBot())
      t_attack_player(ghost:getBot())
   end
   if flags.isMissionStarted then
      return 
   end
   flags.isMissionStarted = true
end

missionComplete = function()
   t_mission_class:showMissInfo("mission_c01", false)
   t_show_message({sender_comp, "T_LOCAL_MISSION_COMPLETE"}, 4, 1)
   doEvent("colony_defended", script.colony)
   _THIS:set("end")
end

missionFailed = function()
   script.colony:set("race", script.race)
   script.colony:set("clan", CLAN_ASTRON)
   t_mission_class:showMissInfo("mission_c01", false)
   t_show_message({sender_comp, "T_LOCAL_MISSION_FAILED"}, 4, 3)
   t_show_message({g_sender_parkan, "T_COLONY_LOST"}, 8, 3)
   doEvent("colony_lost", script.colony)
   script.colony:set("mission", 0)
   update_data_on_failure()
   _THIS:set("end")
end

event.game_change_space_space_complete = function(self)
   if flags.isMissionStarted then
      missionFailed()
   end
end

event.botKilled = function(self, bot)
   if not t_is_land() then
      return 
   end
   local curr_planet = _GAME:get("near_space_object")
   if not t_is_equal_mod(curr_planet, script.colony) then
      return 
   end
   local land_ship = G_LAND:get("Slot", script.land_slot)
   local crew = land_ship:get("crew")
   if crew > 0 then
      return 
   end
   missionComplete()
end

event.hero_is_near_ship = function(self, ghost)
   local curr_planet = G_LAND:get("Planet")
   if not t_is_equal_mod(curr_planet, script.colony) then
      return 
   end
   local land_ship = G_LAND:get("Slot", script.land_slot)
   if not t_is_equal_mod(land_ship, ghost) then
      return 
   end
   land_bots()
end

land_bots = function()
   local land_ship = G_LAND:get("Slot", script.land_slot)
   local ship_race = land_ship:get("race")
   local warbots_count = random(2, 6)
   for index = 1, warbots_count do
      local bot_id = t_table_get_random_value(CLAN_DESC[ship_race].botBox)
      local warbot = t_item_create(land_ship:getBot(), bot_id)
      t_groups_add_item(land_ship:getBot(), G_GROUPS_BOTS, index - 1, warbot)
   end
   t_groups_unload_all(land_ship:getBot(), G_GROUPS_BOTS)
end

OnMissionSet = function(tab)
   if tab[1] and tab[1] == "planet" then
      script.colony = tab[2]
      local planet_pos = script.colony:get("galaxy_pos")
      script.questSystem = planet_pos
   end
end

OnMissionGet = function(tab)
   if tab[1] and tab[1] == "timeToKillMission" then
      return getElapsedTime("doMissionEnd")
   end
end

update_data_on_failure = function()
   local plant = script.colony:get("plant")
   if plant > 0 then
      plant = plant - 1
      script.colony:set("plant", plant)
   end
   local mine = script.colony:get("mine")
   if mine > 0 then
      mine = mine - 1
      script.colony:set("mine", mine)
   end
   t_planet_level_update(script.colony, CLAN_ASTRON)
   local pirates_count = random(18, 24)
   script.star:set("pirates_count", pirates_count)
   local coin = random()
   if coin > 0.75 then
      local planet, index = t_find_suitable_clan_planet_v2(script.race)
      if planet then
         local clan = planet:get("clan")
         if CLAN_PARKAN == clan or CLAN_ASTRON == clan or CLAN_AMAZON == clan then
            return 
         end
         planet:set("clan", CLAN_ASTRON)
      end
   end
end

event.go_time_travel = function(self)
   if script.time_to_finish then
      missionFailed()
   end
end


