
dofile("t_log.lua")
dofile("_old_t.lua")
dofile("t_math.lua")
dofile("t_mission.lua")
dofile("t_mission_class.lua")
dofile("t_clan_const.lua")
dofile("t_clan_desc.lua")
dofile("t_item_func.lua")
dofile("t_module.lua")
dofile("t_ghost.lua")
dofile("t_object_id.lua")
dofile("t_planet_level.lua")
dofile("m_auto_common.lua")
G_SCRIPT_VERSION = 2
EMPIRE_SIZE_GOOD = 1
EMPIRE_SIZE_BAD = 2
EMPIRE_SIZE_CRITICAL = 3
DELAY_COLONY_ASSAULT_MIN = 10
DELAY_COLONY_ASSAULT_MID = 10
DELAY_COLONY_ASSAULT_MAX = 10
script = {}
script.empire = {}
flags = {}
OnMissionSave = function(s)
   s:write(G_SCRIPT_VERSION)
   s:write(script)
   s:write(flags)
end

OnMissionLoad = function(s)
   local load_version = s:read()
   script = s:read()
   flags = s:read()
end

OnMissionStart = function()
end

OnMissionEnd = function()
end

event.planet_capture = function(self, planet, old_clan)
   Log("#m_auto_player_colony  =>  event:planet_capture    --> planet=", planet)
   Log("#m_auto_player_colony  =>  event:planet_capture    --> old_clan=", old_clan)
   local curr_time = getGameTime()
   local planet_pos = planet:get("galaxy_pos")
   local colony = {}
   colony.object = planet
   colony.planet_pos = planet_pos
   colony.time = curr_time
   local index = getn(script.empire)
   script.empire[index + 1] = colony
   LogTable("script.empire", script.empire)
end

event.check_hero_empire = function(self)
   local empire_size = getn(script.empire)
   if empire_size ~= 0 then
      return 
   end
   local delay_assault = nil
   if empire_size <= EMPIRE_SIZE_GOOD then
      delay_assault = DELAY_COLONY_ASSAULT_MAX
   elseif EMPIRE_SIZE_CRITICAL <= empire_size then
      delay_assault = DELAY_COLONY_ASSAULT_MIN
   else
      delay_assault = DELAY_COLONY_ASSAULT_MID
   end
   for index = 1, empire_size do
      local colony = script.empire[index]
      LogTable("script.empire[index]", script.empire[index])
      local curr_time = getGameTime()
      local delta = curr_time - colony.time
      Log("#m_auto_player_colony  =>    event:check_hero_empire --> colony.time=", colony.time)
      Log("#m_auto_player_colony  =>    event:check_hero_empire --> delay_assault=", delay_assault)
      Log("#m_auto_player_colony  =>    event:check_hero_empire --> delta=", delta)
      local busy_flag = colony.object:get("mission")
      Log("#m_auto_player_colony  =>    event:check_hero_empire --> busy_flag=", busy_flag)
      if busy_flag == 1 and delay_assault < delta then
         Log("$------------------------>   \205\192\207\192\196\197\205\200\197 \205\192 \202\206\203\206\205\200\222 \200\195\208\206\202\192!!!")
         t_miss_stop_player_ship()
         local miss = t_mission_add("m_local_c01.lua")
         miss:set("planet", colony.object)
         miss:set("start")
   else
      end
   end
end

event.colony_lost = function(self, ex_colony)
   local empire_size = getn(script.empire)
   Log("#m_auto_player_colony  =>  event:colony_lost --> FIRST empire_size=", empire_size)
   local new_empire = {}
   for index = 1, empire_size do
      if not t_is_equal_mod(ex_colony, script.empire[index].object) then
         new_empire[index] = script.empire[index]
      end
   end
   script.empire = new_empire
   empire_size = getn(script.empire)
   Log("#m_auto_player_colony  =>  event:colony_lost --> LAST empire_size=", empire_size)
end

event.colony_defended = function(self, obj)
   local empire_size = getn(script.empire)
   for index = 1, empire_size do
      if t_is_equal_mod(obj, script.empire[index].object) then
         local curr_time = getGameTime()
         Log("++++++++++++++++++++++++++++++>>> script.empire[index].time   \225\251\235\238:", script.empire[index].time)
         script.empire[index].time = curr_time
         Log("++++++++++++++++++++++++++++++>>> script.empire[index].time   \241\242\224\235\238:", script.empire[index].time)
         return 
      end
   end
end


