
dofile("t_log.lua")
dofile("_old_t.lua")
dofile("t_math.lua")
dofile("t_mission.lua")
dofile("t_mission_class.lua")
dofile("t_clan_const.lua")
dofile("t_clan_desc.lua")
dofile("t_item_func.lua")
dofile("t_module.lua")
dofile("t_ghost.lua")
dofile("t_object_id.lua")
dofile("t_planet_level.lua")
dofile("m_auto_common.lua")
G_SCRIPT_VERSION = 2
EMPIRE_SIZE_GOOD = 1
EMPIRE_SIZE_BAD = 2
EMPIRE_SIZE_CRITICAL = 3
DELAY_BETWEEN_ASSAULT = 10
DELAY_COLONY_ASSAULT_MIN = 10
DELAY_COLONY_ASSAULT_MID = 10
DELAY_COLONY_ASSAULT_MAX = 10
script = {}
script.empire = {}
script.empire[1] = {}
script.empire[2] = {}
script.empire[3] = {}
script.empire[4] = {}
script.empire[5] = {}
script.empire[6] = {}
flags = {}
flags.time_since_last_assault = DELAY_BETWEEN_ASSAULT
OnMissionSave = function(s)
   s:write(G_SCRIPT_VERSION)
   s:write(script)
   s:write(flags)
end

OnMissionLoad = function(s)
   local load_version = s:read()
   script = s:read()
   flags = s:read()
end

OnMissionStart = function()
end

OnMissionEnd = function()
end

event.back_to_Argus = function(self)
   _THIS:set("end")
end

event.planet_capture = function(self, planet, old_clan)
   local curr_time = getGameTime()
   local planet_pos = planet:get("galaxy_pos")
   local colony = {}
   colony.object = planet
   colony.planet_pos = planet_pos
   colony.time = curr_time
   Log("#m_auto_player_colony_v2   ++++++++......  colony added to empire.  in SECTOR:", planet_pos[1])
   local count = getn(script.empire[planet_pos[1] + 1])
   Log("#m_auto_player_colony_v2   ++++++++1st......  count:", count)
   table.insert(script.empire[planet_pos[1] + 1], colony)
   count = getn(script.empire[planet_pos[1] + 1])
   Log("#m_auto_player_colony_v2   ++++++++2nd......  count:", count)
end

event.check_hero_empire = function(self)
   local curr_time = getGameTime()
   local delta = curr_time - flags.time_since_last_assault
   if delta < DELAY_BETWEEN_ASSAULT then
      return 
   end
   local max_filled_sector_index = 0
   local max_bases_count = 0
   local bases = {}
   for i = 1, 6 do
      bases[i] = getn(script.empire[i])
      Log("m_auto_player_colony_v2      ++++++++....    sector: ", i)
      Log("m_auto_player_colony_v2      ++++++++....    bases count: ", bases[i])
      if max_bases_count < bases[i] then
         max_bases_count = bases[i]
         max_filled_sector_index = i
      end
   end
   Log("m_auto_player_colony_v2      ................  max_filled_sector_index=", max_filled_sector_index)
   Log("m_auto_player_colony_v2      ................  max_bases_count=", max_bases_count)
   if max_bases_count < 1 then
      return 
   end
   local delay_assault = nil
   if max_bases_count <= EMPIRE_SIZE_GOOD then
      return 
   elseif EMPIRE_SIZE_CRITICAL <= max_bases_count then
      delay_assault = DELAY_COLONY_ASSAULT_MIN
   else
      delay_assault = DELAY_COLONY_ASSAULT_MID
   end
   Log("m_auto_player_colony_v2      ................  delay_assault=", delay_assault)
   for index = 1, max_bases_count do
      local colony = script.empire[max_filled_sector_index][index]
      LogTable("script.empire[index]", script.empire[index])
      local curr_time = getGameTime()
      local delta = curr_time - colony.time
      Log("#m_auto_player_colony  =>    event:check_hero_empire --> colony.time=", colony.time)
      Log("#m_auto_player_colony  =>    event:check_hero_empire --> delta=", delta)
      local busy_flag = colony.object:get("mission")
      Log("#m_auto_player_colony  =>    event:check_hero_empire --> busy_flag=", busy_flag)
      if busy_flag == 1 and delay_assault < delta then
         Log("$------------------------>   \205\192\207\192\196\197\205\200\197 \205\192 \202\206\203\206\205\200\222 \200\195\208\206\202\192!!!")
         t_miss_stop_player_ship()
         local curr_time = getGameTime()
         flags.time_since_last_assault = curr_time
         if colony.planet_pos[5] ~= -1 then
            t_planet_renew(colony.object)
         else
            t_sat_renew(colony.object)
         end
         local miss = t_mission_add("m_local_c01.lua")
         miss:set("planet", colony.object)
         miss:set("start")
   else
      end
   end
end

event.colony_lost = function(self, ex_colony)
   local empire_size = getn(script.empire)
   Log("#m_auto_player_colony  =>  event:colony_lost --> FIRST empire_size=", empire_size)
   local new_empire = {}
   for index = 1, empire_size do
      if not t_is_equal_mod(ex_colony, script.empire[index].object) then
         new_empire[index] = script.empire[index]
      end
   end
   script.empire = new_empire
   empire_size = getn(script.empire)
   Log("#m_auto_player_colony  =>  event:colony_lost --> LAST empire_size=", empire_size)
end

event.colony_defended = function(self, obj)
   local empire_size = getn(script.empire)
   for index = 1, empire_size do
      if t_is_equal_mod(obj, script.empire[index].object) then
         local curr_time = getGameTime()
         Log("++++++++++++++++++++++++++++++>>> script.empire[index].time   \225\251\235\238:", script.empire[index].time)
         script.empire[index].time = curr_time
         Log("++++++++++++++++++++++++++++++>>> script.empire[index].time   \241\242\224\235\238:", script.empire[index].time)
         return
      end
   end
end


