
dofile("t_log.lua")
dofile("t_math.lua")
dofile("t_clan_const.lua")
dofile("t_mission.lua")
dofile("t_mission_class.lua")
dofile("t_item_func.lua")
dofile("t_module.lua")
dofile("t_ghost.lua")
OnMissionSave = function(s)
end

OnMissionLoad = function(s)
end

OnMissionStart = function()
   create_start_hero_ship()
   create_start_hero()
end

OnMissionEnd = function()
end

create_start_hero = function()
   local act = getActiveGhost()
   local hero = t_create_object_free_scene(OID_GHOST_HERO)
   hero.gh = t_get_ghost(hero)
   hero.gh:set("name_id", "HERO")
   hero.gh:set("clan", CLAN_PARKAN)
   local main_items = {}
   local cannon_items = {}
   local rocket_items = {}
   main_items.generator = t_item_create(act, IID_H_GEN03)
   main_items.radar = t_item_create(act, IID_H_SENS03)
   main_items.shield = t_item_create(act, IID_H_SHLD03)
   main_items.engine = t_item_create(act, IID_H_ENG03)
   cannon_items[1] = t_item_create(act, IID_H_GUN_GM)
   rocket_items[1] = t_item_create(act, IID_ROCK_GM)
   rocket_items[2] = t_item_create(act, IID_ROCK_GM)
   rocket_items[3] = t_item_create(act, IID_ROCK_GM)
   rocket_items[4] = t_item_create(act, IID_ROCK_GM)
   hero.mut = t_get_mutator(hero)
   hero.mut:set("main_items", main_items)
   hero.mut:set("cannon_items", cannon_items)
   hero.mut:set("rocket_items", rocket_items)
   _GAME:set("active_hero", hero.id)
end

create_advanced_hero = function()
   local act = getActiveGhost()
   local hero = t_create_object_free_scene(OID_GHOST_HERO)
   hero.gh = t_get_ghost(hero)
   hero.gh:set("name_id", "HERO")
   hero.gh:set("clan", CLAN_PARKAN)
   local main_items = {}
   local cannon_items = {}
   local rocket_items = {}
   main_items.generator = t_item_create(act, IID_H_GEN03)
   main_items.radar = t_item_create(act, IID_H_SENS01)
   main_items.shield = t_item_create(act, IID_H_SHLD03)
   main_items.engine = t_item_create(act, IID_H_ENG03)
   cannon_items[1] = t_item_create(act, IID_H_GUN_GM)
   cannon_items[2] = t_item_create(act, IID_H_GUN_OB)
   rocket_items[1] = t_item_create(act, IID_ROCK_GM)
   rocket_items[2] = t_item_create(act, IID_ROCK_GM)
   rocket_items[3] = t_item_create(act, IID_ROCK_GM)
   rocket_items[4] = t_item_create(act, IID_ROCK_GM)
   hero.mut = t_get_mutator(hero)
   hero.mut:set("main_items", main_items)
   hero.mut:set("cannon_items", cannon_items)
   hero.mut:set("rocket_items", rocket_items)
   _GAME:set("active_hero", hero.id)
end

create_start_hero_ship = function()
   local g_cache = t_script_get_cache()
   g_cache:set("create_bot", OID_SHIP_INSIDE_PK)
   g_cache:set("mark_create_id", OID_BUILD_INSIDE_PORT01)
   g_cache:set("mark_create_id", OID_BUILD_INSIDE_MINE01)
   g_cache:set("mark_create_id", OID_BUILD_INSIDE_PLANT01)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_HC)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_DC)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_OC)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_XC)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_MC)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_AC)
   local hero_ship = t_create_object_free_scene(OID_GHOST_PK)
   hero_ship.gh = t_get_ghost(hero_ship)
   hero_ship.gh:set("position", {0, 0, -50, 0, 0, 0})
   hero_ship.gh:set("race", CLAN_PARKAN)
   hero_ship.gh:set("clan", CLAN_PARKAN)
   _GAME:set("active_ghost", hero_ship.id)
   local main_items = {}
   local cannon_items = {}
   local rocket_items = {}
   main_items.generator = t_item_create(hero_ship, IID_GEN06)
   main_items.radar = t_item_create(hero_ship, IID_SENS04)
   main_items.shield = t_item_create(hero_ship, IID_SHLD03)
   main_items.engine = t_item_create(hero_ship, IID_ENG05)
   local random_hp = random(600, 900)
   main_items.generator:set("hp", random_hp)
   random_hp = random(300, 500)
   main_items.radar:set("hp", random_hp)
   random_hp = random(300, 500)
   main_items.shield:set("hp", random_hp)
   random_hp = random(800, 1000)
   main_items.engine:set("hp", random_hp)
   cannon_items[1] = t_item_create(hero_ship, IID_GUN_HM_HW)
   cannon_items[2] = t_item_create(hero_ship, IID_GUN_HM_LT)
   rocket_items[1] = t_item_create(hero_ship, IID_ROCK_GM)
   rocket_items[2] = t_item_create(hero_ship, IID_ROCK_GM)
   local mutator = t_get_mutator(hero_ship)
   mutator:set("cannon_items", cannon_items)
   mutator:set("main_items", main_items)
   mutator:set("rocket_items", rocket_items)
   local fuel_count = random(140, 170) * 100
   t_mission_add_fuel(fuel_count)
end

create_advanced_hero_ship = function()
   local g_cache = t_script_get_cache()
   g_cache:set("mark_create_id", OID_BUILD_INSIDE_PORT01)
   g_cache:set("mark_create_id", OID_BUILD_INSIDE_MINE01)
   g_cache:set("mark_create_id", OID_BUILD_INSIDE_PLANT01)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_PK)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_HC)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_DC)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_OC)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_XC)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_MC)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_AC)
   local hero_ship = t_create_object_free_scene(OID_GHOST_XC)
   hero_ship.gh = t_get_ghost(hero_ship)
   hero_ship.gh:set("position", {0, 0, -50, 0, 0, 0})
   hero_ship.gh:set("race", CLAN_PARKAN)
   hero_ship.gh:set("clan", CLAN_PARKAN)
   _GAME:set("active_ghost", hero_ship.id)
   local main_items = {}
   local cannon_items = {}
   local rocket_items = {}
   main_items.generator = t_item_create(hero_ship, IID_GENSUPER)
   main_items.radar = t_item_create(hero_ship, IID_SENSSUPER)
   main_items.shield = t_item_create(hero_ship, IID_SHLDSUPER)
   main_items.engine = t_item_create(hero_ship, IID_ENGSUPER)
   cannon_items[1] = t_item_create(hero_ship, IID_GUN_XN_LT)
   cannon_items[2] = t_item_create(hero_ship, IID_GUN_XN_HW)
   rocket_items[1] = t_item_create(hero_ship, IID_ROCK_GM)
   rocket_items[2] = t_item_create(hero_ship, IID_ROCK_GM)
   rocket_items[3] = t_item_create(hero_ship, IID_ROCK_GM)
   local mutator = t_get_mutator(hero_ship)
   mutator:set("cannon_items", cannon_items)
   mutator:set("main_items", main_items)
   mutator:set("rocket_items", rocket_items)
   t_item_create(hero_ship, IID_H_GRABBER, 1)
   t_item_create(hero_ship, IID_S_JUMPER, 1)
   t_mission_add_fuel(590000)
end

create_tester_hero_ship = function()
   local g_cache = t_script_get_cache()
   g_cache:set("mark_create_id", OID_BUILD_INSIDE_PORT01)
   g_cache:set("mark_create_id", OID_BUILD_INSIDE_MINE01)
   g_cache:set("mark_create_id", OID_BUILD_INSIDE_PLANT01)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_PK)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_HC)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_DC)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_OC)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_XC)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_MC)
   g_cache:set("mark_create_id", OID_SHIP_INSIDE_AC)
   local hero_ship = t_create_object_free_scene(OID_GHOST_XC)
   hero_ship.gh = t_get_ghost(hero_ship)
   hero_ship.gh:set("position", {0, 0, -50, 0, 0, 0})
   hero_ship.gh:set("race", CLAN_PARKAN)
   hero_ship.gh:set("clan", CLAN_PARKAN)
   _GAME:set("active_ghost", hero_ship.id)
   local main_items = {}
   local cannon_items = {}
   local rocket_items = {}
   main_items.generator = t_item_create(hero_ship, IID_GEN05)
   main_items.radar = t_item_create(hero_ship, IID_SENSSUPER)
   main_items.shield = t_item_create(hero_ship, IID_SHLD05)
   main_items.engine = t_item_create(hero_ship, IID_ENG05)
   cannon_items[1] = t_item_create(hero_ship, IID_GUN_MT_LT)
   cannon_items[2] = t_item_create(hero_ship, IID_GUN_MT_HW)
   rocket_items[2] = t_item_create(hero_ship, IID_ROCK_GM)
   rocket_items[1] = t_item_create(hero_ship, IID_ROCK_GM)
   local mutator = t_get_mutator(hero_ship)
   mutator:set("cannon_items", cannon_items)
   mutator:set("main_items", main_items)
   mutator:set("rocket_items", rocket_items)
   t_item_create(hero_ship, IID_H_GRABBER, 1)
   t_item_create(hero_ship, IID_S_JUMPER, 1)
   t_mission_add_fuel(590000)
end

create_tester_hero = function()
   local act = getActiveGhost()
   local hero = t_create_object_free_scene(OID_GHOST_HERO)
   hero.gh = t_get_ghost(hero)
   hero.gh:set("name_id", "HERO")
   hero.gh:set("clan", CLAN_PARKAN)
   local main_items = {}
   local cannon_items = {}
   local rocket_items = {}
   main_items.generator = t_item_create(act, IID_H_GEN02)
   main_items.radar = t_item_create(act, IID_H_SENS02)
   main_items.shield = t_item_create(act, IID_H_SHLD02)
   main_items.engine = t_item_create(act, IID_H_ENG02)
   cannon_items[1] = t_item_create(act, IID_H_GUN_XN)
   rocket_items[1] = t_item_create(act, IID_H_ROCK_XN)
   hero.mut = t_get_mutator(hero)
   hero.mut:set("main_items", main_items)
   hero.mut:set("cannon_items", cannon_items)
   hero.mut:set("rocket_items", rocket_items)
   _GAME:set("active_hero", hero.id)
end


